Unit de20e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTDE11_p;

procedure de20e(F :Proc_FE_DE; M :Integer; var IORDER :Integer;
                IU :Integer; JSTART :Integer; HMIN :Extended;
                EPS :Extended; var X :Extended; var YX :Array of Extended;
                var H :Extended; var BUL :Boolean;
                var YPM :Array of Extended; var DELTY :Array of Extended;
                var RAB :Array of Extended; var IERR :Integer);

implementation

procedure de20e(F :Proc_FE_DE; M :Integer; var IORDER :Integer;
                IU :Integer; JSTART :Integer; HMIN :Extended;
                EPS :Extended; var X :Extended; var YX :Array of Extended;
                var H :Extended; var BUL :Boolean;
                var YPM :Array of Extended; var DELTY :Array of Extended;
                var RAB :Array of Extended; var IERR :Integer);
var
N2,N3,N4,N5,N6,N7,N8,N2P1,N3P1,N8P1,JMAX,IJK1,IJK2,IJK3,IJK4,IJK5,
   IJK6,IJK7,IJK8,MC,JR,JS,JJ,IJ6,IJ7,I6,I7,KH,IK5,IP5,I,J,L,
   K :Integer;
FC,D0 :Real;
ZOTUP,A,G,B,XU,U,C,TA,B1,V,UST :Extended;
KONVF,KONV,BO,BH :Boolean;
D :Array [0..6] of Extended;
const
HALF :Extended = 0.5e0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33;
begin
IERR := 0;
ZOTUP := IntPower(2.0,50);
N2 := M+M;
N3 := N2+M;
N4 := N3+M;
N5 := N4+M;
N6 := N5+N5+N2;
N7 := N6+N5+N3;
N8 := N7+N5+N3;
N2P1 := N2+1;
N3P1 := N3+1;
N8P1 := N8+1;
if ( IORDER > 0 ) and ( IORDER <= 6 ) 
 then goto _1;
IERR := 1;
IORDER := 6;
_1:
JMAX := IORDER+4;
if ( JSTART <> 0 ) 
 then goto _27;
_COM20D.elm1 := X;
IJK4 := N4;
for I:=1 to M do
 begin
  RAB[I-1] := YX[I-1];
  IJK4 := IJK4+1;
  RAB[IJK4-1] := YPM[I-1];
_2:
 end;
F(X,YX,RAB[N3P1-1],M);
_3:
BH := False;
KONVF := True;
_4:
A := H+X;
BO := False;
MC := 1;
JR := 2;
JS := 3;
JJ := 0;
IJ6 := N6-M;
IJ7 := N7-M;
I6 := IJ6;
I7 := IJ7;
for J:=1 to JMAX do
 begin
  IJ6 := IJ6+M;
  IJ7 := IJ7+M;
  if ( not BO ) 
   then goto _5;
  D[1] := 1.777777777777778e0;
  D[3] := 7.111111111111111e0;
  D[5] := 28.44444444444444e0;
  goto _6;
_5:
  D[1] := 2.25e0;
  D[3] := 9.e0;
  D[5] := 36.e0;
_6:
  KONV := True;
  if ( J <= (IORDER/2) ) 
   then KONV := False;
  if ( J <= (IORDER+1) ) 
   then goto _7;
  L := IORDER+1;
  D[L-1] := 4.e0*D[L-3];
  FC := 0.7071068*FC;
  goto _8;
_7:
  L := J;
  D[L-1] := (MC*MC);
  FC := 1.0+(IORDER+1-J)*0.1666667;
_8:
  MC := MC+MC;
  G := H/(MC);
  B := G+G;
  if ( ( not BH) ) or ( (J >= (JMAX-1)) ) 
   then goto _10;
  IJK1 := M;
  IJK2 := N2;
  IJK6 := IJ6;
  IJK7 := IJ7;
  for I:=1 to M do
   begin
    IJK2 := IJK2+1;
    IJK7 := IJK7+1;
    RAB[IJK2-1] := RAB[IJK7-1];
    IJK1 := IJK1+1;
    IJK6 := IJK6+1;
    RAB[IJK1-1] := RAB[IJK6-1];
_9:
   end;
  goto _15;
_10:
  IJK1 := M;
  IJK2 := N2;
  IJK3 := N3;
  for I:=1 to M do
   begin
    IJK1 := IJK1+1;
    RAB[IJK1-1] := RAB[I-1];
    IJK2 := IJK2+1;
    IJK3 := IJK3+1;
    RAB[IJK2-1] := RAB[I-1]+G*RAB[IJK3-1];
_11:
   end;
  KH := MC div 2;
  XU := X;
  for K:=2 to MC do
   begin
    XU := XU+G;
    F(XU,RAB[N2P1-1],RAB[N8P1-1],M);
    IJK1 := M;
    IJK2 := N2;
    IJK8 := N8;
    for I:=1 to M do
     begin
      IJK1 := IJK1+1;
      IJK8 := IJK8+1;
      U := RAB[IJK1-1]+B*RAB[IJK8-1];
      IJK2 := IJK2+1;
      RAB[IJK1-1] := RAB[IJK2-1];
      RAB[IJK2-1] := U;
_12:
     end;
    if ( (K <> KH) ) or ( (K = 3) ) 
     then goto _14;
    JJ := 1+JJ;
    I6 := I6+M;
    I7 := I7+M;
    IJK1 := M;
    IJK2 := N2;
    IJK6 := I6;
    IJK7 := I7;
    for I:=1 to M do
     begin
      IJK2 := IJK2+1;
      IJK7 := IJK7+1;
      RAB[IJK7-1] := RAB[IJK2-1];
      IJK6 := IJK6+1;
      IJK1 := IJK1+1;
      RAB[IJK6-1] := RAB[IJK1-1];
_13:
     end;
_14:
   end;
_15:
  F(A,RAB[N2P1-1],RAB[N8P1-1],M);
  IJK1 := M;
  IJK2 := N2;
  IJK5 := N5;
  IK5 := N5;
  IJK8 := N8;
  for I:=1 to M do
   begin
    IJK1 := IJK1+1;
    IJK2 := IJK2+1;
    IJK5 := IJK5+1;
    IK5 := IK5+1;
    V := RAB[IJK5-1];
    IJK8 := IJK8+1;
    RAB[IJK5-1] := (RAB[IJK2-1]+RAB[IJK1-1]+G*RAB[IJK8-1])*HALF;
    C := RAB[IJK5-1];
    TA := C;
    if ( L < 2 ) 
     then goto _18;
    if ( (Abs(V)*ZOTUP < Abs(C)) ) and ( (H <> HMIN)
 ) and ( (J > IORDER/2+1) ) 
     then goto _26;
    IP5 := IK5;
    for K:=2 to L do
     begin
      IP5 := IP5+M;
      B1 := D[K-1]*V;
      B := B1-C;
      U := V;
      if ( B = 0.e0 ) 
       then goto _16;
      B := (C-V)/B;
      U := C*B;
      C := B1*B;
_16:
      V := RAB[IP5-1];
      RAB[IP5-1] := U;
      TA := U+TA;
_17:
     end;
_18:
    case IU of
     1: goto _19;
     2: goto _20;
     3: goto _21;
    end;
_19:
    UST := Abs(TA);
    if ( UST > YPM[I-1] ) 
     then YPM[I-1] := UST;
    goto _22;
_20:
    YPM[I-1] := Abs(YX[I-1]);
    goto _22;
_21:
    YPM[I-1] := 1.0;
_22:
    DELTY[I-1] := Abs(YX[I-1]-TA);
    YX[I-1] := TA;
    if ( YPM[I-1] < EPS ) 
     then YPM[I-1] := EPS;
    if ( DELTY[I-1] > EPS*YPM[I-1] ) 
     then KONV := False;
_23:
   end;
  if ( KONV ) 
   then goto _31;
  D[2] := 4.0;
  D[4] := 16.0;
  BO := ( ( not BO) );
  IJK4 := N4;
  for I:=1 to M do
   begin
    IJK4 := IJK4+1;
    YPM[I-1] := RAB[IJK4-1];
_24:
   end;
  MC := JR;
  JR := JS;
  JS := MC+MC;
_25:
 end;
BH := ( ( not BH) );
_26:
if ( Abs(H) <= HMIN ) 
 then goto _30;
H := H*HALF;
BUL := False;
if ( Abs(H) >= HMIN ) 
 then goto _4;
H := Sign(HMIN,H);
goto _3;
_27:
for I:=1 to M do
 begin
  YX[I-1] := RAB[I-1];
_28:
 end;
IJK4 := N4;
for I:=1 to M do
 begin
  IJK4 := IJK4+1;
  YPM[I-1] := RAB[IJK4-1];
_29:
 end;
X := _COM20D.elm1;
goto _3;
_30:
KONVF := False;
_31:
H := FC*H;
X := A;
if ( KONVF ) 
 then goto _32;
IERR := 65;
_32:
if ( IERR = 0 ) 
 then goto _33;
UTDE11(IERR,20);
_33:
end;

end.
